#include <windows.h>
#include <stdio.h>

#define jNATIVE	__stdcall
#define jAPI	__cdecl

#define jString long
#define jInt 	long
#define jReal 	long

typedef void		(jAPI *jpAddNative)	(void *routine, char *name, char *prototype);
typedef jString		(jAPI *jpStrMap)	(const char *str);
typedef const char*	(jAPI *jpStrGet)	(jString strid);

jpAddNative	jAddNative	= NULL;
jpStrMap	jStrMap		= NULL;
jpStrGet	jStrGet		= NULL;

jString jNATIVE test()
{
	char *s = "ZOMG TEH FUNC!";
	return jStrMap(s);
}

BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	if (ul_reason_for_call != DLL_PROCESS_ATTACH) return TRUE;
	DisableThreadLibraryCalls(hModule);

	HMODULE hjApi = GetModuleHandle("japi.dll");
	if(!hjApi) throw("Could not locate jAPI");

	jAddNative = (jpAddNative)GetProcAddress(hjApi, "jAddNative");
	if(!jAddNative) throw("Could not find jAddNative");

	jStrMap	= (jpStrMap)GetProcAddress(hjApi, "jStrMap");
	if(!jStrMap) throw("Could not find jStrMap");

	jStrGet	= (jpStrGet)GetProcAddress(hjApi, "jStrGet");
	if(!jStrGet) throw("Could not find jStrGet");

	jAddNative((void *)test, "test", "()S");

	return TRUE;
}
